   This file documents the GNUish MSDOS project, which has the purpose
of providing the feeling of a GNUish environment to MSDOS users.

   Copyright (C) 1990, 1991, 1992, 1993 Free Software Foundation, Inc.

   Permission is granted to make and distribute verbatim copies of this
manual provided the copyright notice and this permission notice are
preserved on all copies.

   Permission is granted to copy and distribute modified versions of
this manual under the conditions for verbatim copying, provided that
the entire resulting derived work is distributed under the terms of a
permission notice identical to this one.

   Permission is granted to copy and distribute translations of this
manual into another language, under the above conditions for modified
versions, except that this permission notice may be stated in a
translation approved by the Free Software Foundation.

Introduction
************

   This is the `MSDOS.info' file for the GNUish MSDOS project, which
has been last updated 20 January 1993.

   You can retrieve a copy of this file by anonymous ftp from
`prep.ai.mit.edu' [18.71.0.38] in directory `pub/gnu/MicrosPorts', as
file `MSDOS.texinfo' for the `Texinfo' source and file `MSDOS.info' for
an already formatted `Info' version.

   Please help the community by kindly reporting all errors or
omissions in this document; for doing so, email to
`pinard@iro.umontreal.ca'. You might also want to contact other authors
or contributors: a list of email addresses is given elsewhere in this
document (see Contributors Addresses.).

   GNUish MSDOS was first organized with small IBM PC's in mind, that
is, 8088 and 80286 based systems.  For 80386 or 80486 based systems, you
should rather take a close look at DJ Delorie's works and derivatives;
these ports have their own set of mailing lists and distribution points.
See cc, for more information.  For OS/2 ports, people should follow
the works of Kai Uwe Rommel and Eberhard Mattes; I've also heard that
many OS/2 ports could be easily made usable under MSDOS with a special
link step on OS/2.

   This document is the work of various people, collected by Francois
Pinard.  The FSF disclaimer (see Project Definition.) is from
Richard Stallman.

   This document contains the following sections:

Project Definition
******************

   The Free Software Foundation (FSF) is not directly interested in
integrating or maintaining ports of GNU software to MSDOS, because of
limited resources.  These activities take time away from finishing a
complete standalone GNU, which FSF and many in the GNU Project considers
much more important.

   However, the organized distribution of such ports started, a few
years ago, under the name "GNUish MSDOS project".  The overall idea is
to provide a GNU like environment for MSDOS, easy to get, and easy to
install, as far as possible.  It contains both MSDOS ports of GNU
software, as well as MSDOS replacements for non-ported GNU software.

   The GNUish MSDOS project wants to consider itself as part of the GNU
project, rather than a mere aggregation of binaries.  The non-GNU
replacements are expected to somewhat comply with the GNU spirit and
standards.  Ideally, all code should be under the GNU General Public
License, should try conforming to the GNU coding standards, and also be
fully ANSI.  The programs should be such that MSDOS users can be
convinced of the virtues of free software!

   The GNU General Public License article 3a) requires that the complete
source code be available where programs are distributed in object code
or executable form.  For convenience, ready-to-execute binaries are also
provided for those who do not have the necessary compilers, or do not
feel like using them.

   When several ports of the same tool exist, one of them has been
selected for inclusion in this documentation.  This does not means that
the selected port is the best possible, it means however that the port
seems to be good.  Nobody should feel offended by any selection.
Questions regarding the GNUish MSDOS project should be directed to the
mailing list:

     help-gnu-msdos@sun.soe.clarkson.edu

   See Project Mailing Lists, for how to subscribe.

   The GNUish MSDOS project originated from Thorsten Ohl.  It has been
moderated by Thorsten from its beginning and for a long while.  Thorsten
originally thought than, giving the project a solid initial impulse, it
would bring enough enthousiasm so other programmers will share the
porting duties.  It now seems that the enthousiasm was more on the
users' side than the programmers' side.  In these days, many parts of
GNUish MSDOS are almost completely dormant, and most products are quite
old relative to the current GNU versions.  Notably alive, however, are
Mike Brennan's mawk, then Len Reed and Stuart Phillips ports of Perl.

   On the 80386/80486 side, DJ Delorie astonishing work on GNU C/C++
gave a new momentum for other MSDOS ports.  Besides a variety of
libraries, we should especially underline the Manabu Higashida and
Hirano Satoshi port of GNU Emacs to MSDOS.

Legal Conditions
****************

   Some tools are possibly dangerous if you do not thoroughly understand
their usage (v.g. `rm -r *').  You ought to know what you are doing.
YOU USE THESE TOOLS AT YOUR OWN RISK.  You *were* warned!

   All these programs are free software; you can redistribute them
and/or modify them under the terms of the GNU General Public License as
published by the Free Software Foundation; either version 1, or (at
your option) any later version.

   These programs are distributed in the hope that they will be useful,
BUT WITHOUT ANY WARRANTY WHATSOEVER, without even the implied
warranties of merchantability or fitness for a particular purpose.  See
the GNU General Public License (the file `COPYING') for more details.

   You should have received a copy of the GNU General Public License
along with GNUish MSDOS programs; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA or e-mail to
`gnu@prep.ai.mit.edu'.

Distribution on Diskettes
*************************

   The FSF is now distributing some of the GNU software that has been
ported to MS-DOS on 3.5 inch, 1.44MB diskettes.  The disks contain both
source and executables.

   Of course, there are deep differences between GNU and MSDOS, so some
of these utilities are necessarily missing features on MSDOS.

   For the 80386 and 80486 only, there are ports of GNU Emacs (see
emacs.) and GNU C/C++ (see cc.).  The following software will run
on 8086 and 80286--based machines; it does not require an 80386. Bison
(see yacc.), RCS (see rcs.), `flex' (see lex.), GAWK (see
awk.), `cpio' (see cpio.), `diff' (see diff.), MicroEmacs
(see emacs.), `find' (see find.), some file utilities (see
utilities.), `gdbm' (see dbm_3.), `grep' (see grep.), `libc'
(see libc_3.), `ptx' (see ptx.), `indent' (see indent.),
`less' (see less.), `m4' (see m4.), `make' (see make.),
`sed' (see sed.), `shar' (see shar.), `sort' (see sort.),
and Texinfo (see texinfo.).

Archiving Formats
*****************

   Traditionally, GNUish MSDOS archives are made using Rahul Dhesi's
`zoo' archiver.  This archive format is popular and portable, used in
many places, notably for the Usenet `comp.binaries.ibm.pc' exchange
group.  The GNUish MSDOS project selected it because it works both on
MSDOS and UNIX, and all the sources are freely available. Moreover, it
offers a nice user interface and is dependable.

   Some people wanted GNUish MSDOS to use `zip' for its better
compression, but `zip' was proprietary software at that time.  A new
version of `zoo' (version 2.1) offers a higher compression rate,
comparable to what `zip' can achieve.  About at the same time, the
`Info-ZIP' group produced a `zip' program available in source form, and
which work both on MSDOS and UNIX.  There are no more big reasons for
using one instead of another.

   Also, some sites converted all of GNUish MSDOS to `ARC' or `LHarc'
format.  Instead of feeding an archivers war, let us simply hope that
each archive site will follow the GNU spirit and at least offer the
free archiver they use, both in executable and complete source form.

   Most packages consists of two archives, one for the complete source
and documentation, the other for the executable and data files;
however, it happens that the documentation is sometimes provided with
the executables.  The filename for a package archive is often selected
according to the following pattern:

     PROGRAM VERSION EDITION SEQUENCE.EXTENSION

   In this syntax, PROGRAM is a short string to identify the product,
e.g. `futi' indicates GNU file utilities; while VERSION is a decimal
integer naming the version, without any decimal point, v.g. `14' for
1.4, `358' for 3.58; EDITION is `a' for the first release in GNUish
MSDOS, then `b', `c', etc.  for subsequent editions.  The value of
SEQUENCE is the letter `s' for the source and documentation, or `x' for
executable and data files.  When EXTENSION is `zoo', this usually
refers to Zoo version 2.1.

FTP Archive Sites
*****************

   The official GNU home is `prep.ai.mit.edu' [18.71.0.38] (problems
with `prep' should be reported to `gnu@prep.ai.mit.edu'). There is
currently no room on `prep.ai.mit.edu' to put GNUish MSDOS files up for
ftp.  If `prep' get more disk space, they might become available.  The
collection of programs known as the GNUish MSDOS project is still
available for ftp at the following addresses.  Different archiving
sites might use different archivers.  The actual extension of any given
archive should give you a clue about which archiver to use. [Upload
directories are listed for the moderator's convenience only].

   The expression "from the usual places", later in this document,
refers to the three first sites of this list.

   * `ftp.iro.umontreal.ca' [132.204.32.22], in `pub/Internet/gnuish'.

     Archives are uploaded there first.

   * `vulcan.phyast.pitt.edu' [130.49.33.16], in `pub/gnuish'.

     Archives are uploaded in [`incoming'] from the `iros1' copy, then
     Roberto move them to their proper place.

   * `wuarchive.wustl.edu' [128.252.135.4], in `systems/msdos/gnuish'.

     Archives are uploaded in place directly from the `iros1' copy.

   * `wsmr-simtel20.army.mil' [192.88.110.20], in `pd1:<msdos.gnuish>'.

     David repacks from `.zoo' to `.arc' before uploading, because
     SIMTEL20 (which uses TOPS20) does not support `.zoo' files.

   * `funic.funet.fi' [128.214.6.100], in `pub/msdos/utilities/gnuish'.

     Petri automatically gets new products from SIMTEL20, and repacks
     files from `.arc' to `.lzh'.  [`pub/msdos/incoming']

   The organization and maintainance of the archive sites is the work of
Francois Pinard, Roberto Gomez, Petri Hartoma, David Camp, Keith
Petersen, Chris Myers, Dave Curry and Russ Nelson.

GNUish Msdos Contents
*********************

   The following contents for GNUish MSDOS is loosely organized along
the lines of related UNIX man pages.

awk
===

   GNU `awk' current GNU version is 2.14.  There is a faster `awk',
also distributed under the GNU General Public License, written by Mike
Brennan.  For the original distribution, fetch executables in
`mawk1.zip' and sources in `mawk1.1.tar.Z' from `oxy.edu', in `public'.
 Or fetch executables and documentation in `mawk11ax.zoo' and sources
in `mawk11as.zoo' from the usual places.

cc
==

   GNU C current GNU version is 2.3.3.  There is no port of GNU C
available for 8088 and 80286 systems, and it is very unlikely that
there would ever be one.  So, GNUish MSDOS is still relying on
proprietary compilers for its existence.  Currently, ports have been
done using Microsoft C compilers or Borland Turbo C/C++; it seems so
far that Microsoft C generates faster code, works better with huge
pointers, and offers a working `alloca()'; but promoting proprietary
software is against the GNU goals, any step in the direction of
compiler independence would be beneficial for the community.

   GNU C had indeed been ported to 80386 MSDOS, under the name `djgpp',
by DJ Delorie.  This opens wide doors for porting further GNU software
for 80386 systems under MSDOS, for those many GNU programs requiring a
fair amount of addressing space.  However, beware that `djgpp' based
ports always require a 80386 machine.

   DJ Delorie made 32-bit 80386 MSDOS extender with symbolic debugger,
and using it, a complete port of GNU C/C++ compiler with utilities,
development libraries, and source code.  It generates full 32-bit
programs and supports full virtual memory with paging to disk.  It
requires at least 5MB of hard disk space to install, and 512K of RAM to
use.  It is compatible with XMS memory managers and VCPI, but not with
Microsoft Windows extended mode or other DPMI managers.  It cannot
emulate multitasking (e.g. `fork(2)') or signals.

   All this can be anonymously ftp'ed from `barnacle.erc.clarkson.edu'
[128.153.28.12] in `pub/msdos/djgpp'. First fetch and carefully read
the three files `readme.1st', `readme' and `faq' from that directory;
or else the cumulative file `MSDOS.gcc' from `prep.ai.mit.edu'
[18.71.0.38], in `pub/gnu/MicrosPorts'. File `README.gcc' should also
be available from the usual places.

compress
========

   `compress' current GNU version is 4.0.1.  GNUish MSDOS has not
selected any current port yet, but many are available.

cpio
====

   GNU `cpio' current GNU version is 2.2.  Version 1.1 has been ported
to MSDOS by Thorsten Ohl.  Fetch executables in `cpio11ax.zoo' and
sources and documentation (inside `readme') in `cpio11as.zoo' from the
usual places.  You also need Thorsten Ohl's `gnulib' to compile it.

   Working on GNU cpio port:
     92-02-24 Matthew J. D'Errico <doc@magna.com>

ctags
=====

   GNU `[ce]tags' current GNU version comes from GNU Emacs
distribution, currently 18.59.  Russ Nelson made a version for Freemacs.
For the original distribution, fetch `etags.zip' from
`grape.ecs.clarkson.edu' [128.153.28.129], in `pub/msdos/freemacs'. Or
fetch the executables, sources and documentation as `etags.zoo' from
the usual places.

diff
====

   GNU `diff' current GNU version is 2.0.  Version 1.15 has been ported
to MSDOS by Thorsten Ohl, using Microsoft C v5.1 or v6.0.  Fetch
executables in `dif115ax.zoo' and sources in `dif115as.zoo' from the
usual places.  There is no documentation.

   There is a 386/468 port of GNU diff 1.15 in the djgpp package.

emacs
=====

   GNU Emacs current GNU version is 18.59.  There is no port of GNU
`emacs' available for 8088 and 80286 systems, and it is very unlikely
that there would ever be one.  Any Emacs for small MSDOS systems only
implements a tiny subset of the true thing.

   Russ Nelson's Freemacs is closest in spirit to the real thing, by
providing a full extension language.  Version 1.6a can be gotten from
various places (`clarkson', `wustl', `simtel', ...). It is made of a
`MINT' interpreter written in 8088 assembler, and of several `MINT'
code application files to drive `emacs' modes.  `MINT' has no relation
to GNU Emacs LISP and limits itself to 64k per file.  For the original
distribution, fetch all from `grape.ecs.clarkson.edu' [128.153.28.129],
in `pub/msdos/freemacs'. Or fetch the executables code as
`emacs16a.zoo' (plus `emacs100.zoo' for a Zenith Z-100) and the sources
as `emac16as.zoo', from the usual places; also fetch some EGA utilities
as `emacsega.zoo' and a spelling checker as `emacspel.zoo'. You might
want to fetch `emacspat.zoo' too for a few patches, applied by Freemacs
itself.

   Jonathan Payne's Jove, on the other side, is not extendable, but can
handle surprisingly big files on MSDOS.  It is well featured and
reasonably fast.  It can be made almost comfortable to GNU Emacs users,
given a proper `jove.rc'.

   GNU Emacs has indeed been ported to 80386 MSDOS by Manabu Higashida
and Hirano Satoshi, under the name Demacs, using DJ Delorie port of GNU
C. The current version is 1.2.0, 91-12-12, and corresponds to Emacs
18.55 with some changes from Emacs 18.57.  One version handles 8-bit
characters sets, the other, based on Nemacs, handles 16-bit character
sets, including Kanji.  It is compatible with XMS memory managers and
VCPI, but not with Microsoft Windows extended mode or other DPMI
managers.  Fetch binaries and diffs from `utsun.s.u-tokyo.ac.jp', in
`GNU/demacs'.  First fetch and carefully read the file `README' from
that directory; or else the file `MSDOS.emacs' from `prep.ai.mit.edu'
[18.71.0.38], in `pub/gnu/MicrosPorts'. File `README.emacs' should also
be available from the usual places.

   Craig Finseth maintains a list of Emacs Implementations and
Literature; fetch `emacs' from `mail.unet.umn.edu' [128.101.101.103], in
`import/fin'.

   Eberhard Mattes writes that GNU Emacs for OS/2 2.0 is available on
`ftp-os2.nmsu.edu' and on `ftp.uni-stuttgart.de' in `soft/os2' as
`emacs-18.58.3'.

find
====

   GNU `find' current GNU version is 3.7, comprising: `find', `locate'
and `xargs'.  Version 1.2 has been ported to MSDOS by Thorsten Ohl.
Fetch executables in `find12ax.zoo' and sources and some documentation
(inside `readme') in `find12as.zoo' from the usual places.  You also
need Thorsten Ohl's `gnulib' to compile it.  Fetch `find12.zoo' from
the usual places.

ghostscript
===========

   Get executables in `ghostscript-2.5.2msdos.exe' and sources in
`ghostscript-2.5.2.tar.Z' from `prep.ai.mit.edu' [18.71.0.38], in
`pub/gnu'. You might need `ghostscript-fonts-2.5.2.tar.Z' from the same
place.

grep
====

   GNU `fgrep' current GNU version is 1.1.  Version 1.1 has been ported
to MSDOS by Thorsten Ohl.  Fetch executables in `fgre11ax.zoo' and
sources in `fgre11as.zoo' from the usual places.  There is no
documentation.

   GNU `grep' current GNU version is 1.6 (+patch), comprising: `grep'
and `egrep'.  Version 1.5 has been ported to MSDOS by Thorsten Ohl.
Fetch executables in `grep15ax.zoo' and sources in `grep15as.zoo' from
the usual places.  There is no documentation.

gzip
====

   GNU `gzip' current GNU version is 0.7.  Version 0.7 has been ported
to MSDOS by Jean-loup Gailly, the `gzip' author.  Fetch executables and
documentation in `gzip07ax.zoo' and sources in `gzip07as.zoo' from the
usual places.

indent
======

   GNU `indent' current GNU version is 1.6.  Version 1.1 has been
ported to MSDOS by Thorsten Ohl.  Fetch executables in `inde11ax.zoo'
and sources and Texinfo unformatted documentation in `inde11as.zoo'
from the usual places.

less
====

   `less' current GNU version is 177.  Version 177 has been ported to
MSDOS by Mark Lord, using Borland C.  For the original distribution,
fetch executables and sources in `less177e.zip' from
`wuarchive.wustl.edu' in `mirrors/msdos/txtutl'. Or fetch executables
in `les177ax.zoo' and sources in `les177as.zoo' from the usual places.

lex
===

   Fast `lex' current GNU version is 2.3.7.  Version 2.3.6 has been
ported to MSDOS by Thorsten Ohl.  Fetch executables in `fle236ax.zoo'
and sources and roff unformatted documentation in `fle236as.zoo' from
the usual places.  You also need Thorsten Ohl's `gnulib' to compile it.

m4
==

   GNU `m4' current GNU version is 1.0.3.  Version 0.5 (also called
0.50) has been ported to MSDOS by Thorsten Ohl.  Fetch executables in
`m4v05ax.zoo' and sources and Texinfo unformatted or DVI ready
documentation in `m4v05as.zoo' from the usual places.  You also need
Thorsten Ohl's `gnulib' to compile it.

make
====

   GNU `make' current GNU version is 3.62.  Version 3.58 has been
ported to MSDOS by Thorsten Ohl, using Microsoft C v6.0.  Fetch
executables in `mak358ax.zoo' and sources and Texinfo + roff
unformatted documentation in `mak358as.zoo' from the usual places. You
also need Thorsten Ohl's swapping library, fetch `swalibas.zoo' from
the usual places.  If you intend to recompile `make', beware that one
patch has been lost for the makefile in `make358as.zoo', so the
makefile might not work as is.

   Working on GNU make port:
     92-09-03 Pax Ken Holmberg <kenh@tfs.com>

patch
=====

   Larry Wall's `patch' current GNU version is 2.0.12g8.  GNUish MSDOS
has not selected any current port yet, but many are available.

perl
====

   Larry Wall's `Perl' current GNU version is 4.035.  Version 4.019 has
been ported to by Stuart Phillips, using Borland C++ 3.0 and VROOM, it
works faster with extended memory.  For the original distribution,
fetch executables in `bcv14_perl4-019E.zip' and sources in
`bcv14_perl4-019.zip' plus `xspawn34.zip' from `tandem.com'
[130.252.12.8], in `pub/perl'. Or fetch executables in `pl4019ax.zoo'
and sources in `pl4019as.zoo' from the usual places.  There is no
documentation.

   Also, version 4.000 has been ported to MSDOS by Len Reed.  Fetch
executables in `perl_exe.zoo' from `eeserv.ee.umanitoba.ca'
[130.179.8.1] in `pub/msdos/perl'.

ptx
===

   GNU `ptx' current GNU version is 0.2.  Version 0.1 has been ported
to MSDOS by Thorsten Ohl.  Fetch executables in `ptx01ax.zoo' and
sources and documentation in `ptx01as.zoo' from the usual places.

rcs
===

   GNU Revision Control System current GNU version is 5.6.  Version 5.5
has been ported to MSDOS by Stuart Phillips.  For the original
distribution, fetch sources and executables in `rcs55.zip' from
`wuarchive.wust.edu', in `mirrors/msdos/pgmutil'. Or fetch executables
in `rcs55ax.zoo' and sources and roff unformatted documentation in
`rcs55as.zoo' from the usual places.

sed
===

   GNU `sed' current GNU version is 1.13.  Version 1.06 has been ported
to MSDOS by Thorsten Ohl.  Fetch executables in `sed106ax.zoo' and
sources in `sed106as.zoo' from the usual places.  You also need
Thorsten Ohl's `gnulib' to compile it. There is no documentation.

sh
==

   GNU `bash' current GNU version is 1.12.  There is no port of GNU
`bash' available to 8088 and 80286 systems yet, but the techniques used
in `perl' (see perl.) and `make' (see make.) make it in
principle possible to run programs of this size under MSDOS.

   Ian Stewartson ported the Charles Forsyth `sh' from MINIX to MSDOS,
using Microsoft C v5.1.  For the original distribution, fetch
executables in `ms_sh164.zip' from `wuarchive.wustl.edu', in
`mirrors/msdos/sysutl'; fetch sources from `comp.sources.misc' in
Volume 10 issues 053-059, Volume 12 issues 019-026, Volume 13 issues
079-080, Volume 14 Issues 065-066, Volume 16 Issues 078-079.  Or fetch
executables and documentation in `sh164ax.zoo' and sources in
`sh164as.zoo' from the usual places.

shar
====

   `shar' current version is 3.49.  It has been distributed through
`alt.sources' on 90-09-24.  Version 3.49 has been ported to MSDOS by
Thorsten Ohl.  Fetch executables in `sha349ax.zoo' and sources and roff
unformatted documentation in `sha349as.zoo' from the usual places.

sort
====

   GNU `sort' current GNU version is found within GNU Text Utilities
version 1.3.  A prerelease of version 0.3 has been ported to MSDOS by
Thorsten Ohl.  Fetch executables and documentation in `sort03ax.zoo'
and sources in `sort03as.zoo' from the usual places.

tar
===

   GNU `tar' current GNU version is 1.11.1.  GNUish MSDOS has not
selected any current port yet, but many are available.

texinfo
=======

   GNU `texinfo' current GNU version is 2.16, comprising: `info',
`makeinfo', `texi2dvi', `texindex' and extensive related code written
in GNU Emacs LISP.  Prereleased versions of `info' and `makeinfo' have
been ported to MSDOS by Thorsten Ohl.  Fetch executables in
`texi10ax.zoo' and sources in `texi10as.zoo' from the usual places.
There is no documentation.

file/text utilities
===================

   GNU File Utilities current GNU version is 3.4, comprising: `chgrp',
`chmod', `chown', `cp', `dd', `df', `dir', `du', `install', `ln', `ls',
`mkdir', `mkfifo', `mknod', `mv', `rm', `rmdir', `touch' and `vdir'.
GNU Text Utilities current GNU version is 1.3, comprising: `cat',
`cmp', `comm', `csplit', `cut', `expand', `fold', `head', `join', `nl',
`paste', `pr', `sort', `split', `sum', `tac', `tail', `tr', `unexpand',
`uniq' and `wc'.

   GNU Text Utilities historically emerged from GNU File Utilities; and
version 1.4 have been ported to MSDOS by Thorsten Ohl before this split
has been done.  The ported programs are: `cat', `chmod', `cmp', `cp',
`cut', `dd', `dir', `head', `ls', `mkdir', `mv', `paste', `rmdir',
`tac', `tail', `touch', `vdir' and `rm'.  Fetch executables and roff
unformatted (or Texinfo, through a Perl script) documentation in
`futi14ax.zoo' and sources in `futi14as.zoo' from the usual places.

   The GNU `sort' program is documented elsewhere (see sort.).

yacc
====

   GNU `bison' current GNU version is 1.19.  This version compiles
without changes on MSDOS.  Fetch sources in `bison-1.19.tar.Z' from
`prep.ai.mit.edu' [18.71.0.38], in `pub/gnu'.

   Since `bison' is used to produce C source which will further be
compiled, it is assumed that a `bison' user has a C compiler, thus s/he
can compile bison itself from sources.  This why bison executables are
not generally available for MSDOS.  The following patch is reported:

     *** files.c~	Thu Nov 19 15:12:52 1992
     --- files.c	Thu Nov 19 15:15:12 1992
     ***************
     *** 389,394 ****
     --- 389,395 ----
         if (actfile) unlink(actfile);
         if (tmpattrsfile) unlink(tmpattrsfile);
         if (tmptabfile) unlink(tmptabfile);
     +   if (tmpdefsfile) unlink(tmpdefsfile);
       #endif /* MSDOS */
         exit(k);
       #endif /* not VMS */

zoo
===

   Rahul Dhesi's barebone Zoo extractor version 2.0 has been distributed
through `comp.binaries.ibm.pc' (1 part: `v13i001').  Fetch `booz.exe'
and `booz20.zoo' from the usual places.  Use `booz.exe' under MSDOS to
unpack the sources and documentation in `booz20.zoo'.

   Rahul Dhesi's full Zoo current version is 2.1 (also called 2.10).
Executables have been distributed in `comp.binaries.ibm.pc' (3 parts:
v13i002-004), sources has been distributed through `alt.sources' on
91-07-10 (14 parts).  Fetch the executables in `zoo210.exe' and sources
in `zoo210s.zoo' from the usual places.  Execute the self extracting
`zoo210.exe' under MSDOS to unpack the zoo executables and
documentation.  Unpack the sources with the obtained `zoo.exe'.

dbm_3
=====

   GNU `dbm' current GNU version is 1.5.  Version 1.4 has been ported
to MSDOS by Thorsten Ohl.  Fetch sources in `gdbm14as.zoo' from the
usual places.  There is no executables archive associated with GNU dbm.
There is no documentation.

libc_3
======

   Many library routines frequently occurring in various GNU products
have been ported to MSDOS by Thorsten Ohl, to help other ports.  Fetch
sources in `gnulibas.zoo' from the usual places.  There is no
executables archive associated with Thorsten Ohl's `gnulib'.  There is
no documentation.

   A swapping library has been developped by Thorsten Ohl, using
Microsoft C v6.0, to be used by some of his other GNU ports.  Fetch
sources and (TeX unformatted?) documentation in `swalibas.zoo' from the
usual places.  There is no executables archive associated with Thorsten
Ohl's `swaplib'.

   Note that this is not a complete `libc(3)', but rather a small
collection of GNU specific routines.

chess_6
=======

   GNU `chess' current GNU version is 4.0.60.  This version should
compile without changes on MSDOS, please someone give me a pointer to an
already prepared executable.  Fetch sources in
`gnuchess-4.0.pl60.tar.Z' from `prep.ai.mit.edu' [18.71.0.38], in
`pub/gnu'.

Project Mailing Lists
*********************

   There are some mailing lists to discuss MSDOS ports of GNU software.
They include:

     bug-gnu-msdos@sun.soe.clarkson.edu     bug reports, enhancements
     help-gnu-msdos@sun.soe.clarkson.edu    questions and answers
     info-gnu-msdos@sun.soe.clarkson.edu    announcements, moderated
     djgpp@sun.soe.clarkson.edu             80386 djgpp discussions

   To get on or off one of these lists, send a request to:

     listserv@sun.soe.clarkson.edu

   or, if you don't get a reply, to:

     bug-gnu-msdos-request@sun.soe.clarkson.edu
     help-gnu-msdos-request@sun.soe.clarkson.edu
     info-gnu-msdos-request@sun.soe.clarkson.edu
     djgpp-request@sun.soe.clarkson.edu

   Note: do *not* send requests to the lists, only the `listserv'!

   For example, to become subscribed to the list `info-gnu-msdos', send
a message whose contents (not the `Subject') is:

     add info-gnu-msdos

   If you don't know how to use a `listserv', send it a request for
help.  Do this by sending it a mail message consisting of the word
`help', without quotes, of course.  If you don't get a reply, include
an Internet return address with the command `path user@host.dom.ain',
replacing `user@host.dom.ain' with your Internet email address.

   The lists are not currently digestified, and are open to
subscription by anyone.  The `info-gnu-msdos' mailing list is moderated
by Russell Nelson, solely to ensure that only announcements get sent to
the list (and not requests!).  Problems with the mailing lists should
be directed to the appropriate `-request' list.  For the newcomers: an
Internet standard for mailing lists is to provide a mail alias that has
the same name as the list, with `-request' appended, e.g.
`info-gnu-msdos-request'.

   Also, please consider these lists as GNU project subsidiary mailing
lists.  They were made up after the GNUish MSDOS project, not before,
and their intent is to help to keep to project moving, *not* to change
its definition or meaning.  There are several lists already and other
means to discuss non-GNUish software for MSDOS; there are other lists
to discuss the pros and cons of the GNU project itself.  You can nask
`gnu@prep.ai.mit.edu' for a description of these other lists.

   The mailing lists were organized by David Camp, Len Tower, Russ
Nelson and DJ Delorie.

Historical Notes
****************

   Thorsten Ohl started his ports in November 1989, in Germany, while
the Berlin Wall was falling.  He subscribed at some GNU mailing lists
and, for correspondants wanting his MSDOS ports, organized a
distribution list based on email and still located in Germany.  In
1990, around spring, the unusual quality of Thorsten ports was being
recognized, and a few FTP sites organized to hold them (`vulcan',
`simtel', `wuarchive', `ocf', `funic'); during the summer, the mailing
lists were created.  Thorsten stopped actively porting GNU products to
MSDOS in September 1990, to finish his PhD and continue his research in
theoretical high energy physics.  He has now joined the endless list of
people who support GNU by using GNU software on their UNIX workstations
and contribute bug reports and (occasionally) fixes.

   At this point, the mailing lists, after an initial burst of intense
activity and many debates, became very quiet, and nothing really new got
added to the GNUish MSDOS archives.  DJ Delorie released his 80386 port
of GNU C/C++, and GNU Emacs itself was ported to 80386 under the name
Demacs.

   In February 1992, the archives were reorganized to better comply with
the GPL, which requires the sources to be fully available at the
distribution points.  Ports from Russell Nelson and Stuart Phillips were
integrated in the project.

Contributors Addresses
**********************

   Here are the electronic addresses of all people quoted elsewhere in
this document:

     Chris Myers `chris@wugate.wustl.edu'
     Craig A. Finseth `fin@unet.umn.edu'
     DJ Delorie `dj@ctron.com'
     David A. Curry `davy@erg.sri.com'
     David J. Camp `david@wubios.wustl.edu'
     Eberhard Mattes `mattes@azu.informatik.uni-stuttgart.de'
     Francois Pinard `pinard@iro.umontreal.ca'
     Hirano Satoshi `hirano@tkl.iis.u-tokyo.ac.jp'
     Ian Stewartson `istewart@datlog.co.uk'
     Jonathan Payne
     Kai Uwe Rommel `rommel@informatik.tu-muenchen.de'
     Keith Petersen `w8sdz@wsmr-simtel20.army.mil'
     Len Reed `holos0!lbr@gatech.edu'
     Leonard Tower Jr. `tower@prep.ai.mit.edu'
     Manabu Higashida `manabu@sigmath.osaka-u.ac.jp'
     Mark Lord `mlord@bnr.ca'
     Mike Brennan `brennan@boeing.com'
     Petri Hartoma `msdos1@nic.funet.fi'
     Rahul Dhesi `dhesi@cirrus.com'
     Richard Stallman `rms@gnu.ai.mit.edu'
     Roberto Gomez `roberto@bondi.phyast.pitt.edu'
     Russell Nelson `nelson@sun.soe.clarkson.edu'
     Stuart Phillips `stu@tandem.com'
     Thorsten Ohl `ohl@gnu.ai.mit.edu'